Wt: Wt::WPopupMenu Class Reference

Wt 4.10.4

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | List of all members
Wt::WPopupMenu Class Reference

A menu presented in a popup window. More...

`#include <Wt/WPopupMenu.h>`

Inheritance diagram for Wt::WPopupMenu:
[legend]

## Public Member Functions
| WPopupMenu (WStackedWidget *contentsStack=nullptr)
| Creates a new popup menu.
void | popup (const WPoint &point)
| Shows the the popup at a position.
void | popup (const WMouseEvent &event)
| Shows the the popup at the location of a mouse event.
void | popup (WWidget *location, Orientation orientation=Orientation::Vertical)
| Shows the popup besides a widget.
WMenuItem * | exec (const WPoint &point)
| Executes the the popup at a position.
WMenuItem * | exec (const WMouseEvent &event)
| Executes the the popup at the location of a mouse event.
WMenuItem * | exec (WWidget *location, Orientation orientation=Orientation::Vertical)
| Executes the popup besides a widget.
WMenuItem * | result () const
| Returns the last triggered menu item.
virtual void | setHidden (bool hidden, const WAnimation &animation=WAnimation()) override
| Hides or shows the widget.
virtual void | setMaximumSize (const WLength &width, const WLength &height) override
| Sets a maximum size.
virtual void | setMinimumSize (const WLength &width, const WLength &height) override
| Sets a minimum size.
Signal & | aboutToHide ()
| Signal emitted when the popup is hidden.
Signal< WMenuItem * > & | triggered ()
| Signal emitted when an item is selected.
void | setAutoHide (bool enabled, int autoHideDelay=0)
| Configure auto-hide when the mouse leaves the menu.
void | setHideOnSelect (bool enabled=true)
| Set whether this popup menu should hide when an item is selected.
bool | hideOnSelect () const
| Returns whether this popup menu should hide when an item is selected.
Public Member Functions inherited from Wt::WMenu
| WMenu ()
| Creates a new menu.
| WMenu (WStackedWidget *contentsStack)
| Creates a new menu.
| ~WMenu ()
| Destructor.
WMenuItem * | addItem (const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| Adds an item.
WMenuItem * | addItem (const std::string &iconPath, const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| Adds an item.
template<class T , class V >
WMenuItem * | addItem (const WString &text, T *target, void(V::*method)())
| Adds an item with given text, and specify a slot method to be called when the item is triggered.
template<class T , class V >
WMenuItem * | addItem (const std::string &iconPath, const WString &text, T *target, void(V::*method)())
| Adds an item with given text and icon, and specify a slot method to be called when activated.
WMenuItem * | addMenu (const WString &text, std::unique_ptr< WMenu > menu)
| Adds a submenu, with given text.
WMenuItem * | addMenu (const std::string &iconPath, const WString &text, std::unique_ptr< WMenu > menu)
| Adds a submenu, with given icon and text.
virtual WMenuItem * | addItem (std::unique_ptr< WMenuItem > item)
| Adds an item.
WMenuItem * | insertItem (int index, const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| inserts an item.
WMenuItem * | insertItem (int index, const std::string &iconPath, const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
| inserts an item.
template<class T , class V >
WMenuItem * | insertItem (int index, const WString &text, T *target, void(V::*method)())
| inserts an item with given text, and specify a slot method to be called when the item is triggered.
template<class T , class V >
WMenuItem * | insertItem (int index, const std::string &iconPath, const WString &text, T *target, void(V::*method)())
| inserts an item with given text and icon, and specify a slot method to be called when activated.
WMenuItem * | insertMenu (int index, const WString &text, std::unique_ptr< WMenu > menu)
| inserts a submenu, with given text.
WMenuItem * | insertMenu (int index, const std::string &iconPath, const WString &text, std::unique_ptr< WMenu > menu)
| inserts a submenu, with given icon and text.
virtual WMenuItem * | insertItem (int index, std::unique_ptr< WMenuItem > item)
| Inserts an item.
WMenuItem * | addSeparator ()
| Adds a separator to the menu.
WMenuItem * | addSectionHeader (const WString &text)
| Adds a section header to the menu.
virtual std::unique_ptr< WMenuItem > | removeItem (WMenuItem *item)
| Removes an item.
void | select (WMenuItem *item)
| Selects an item.
void | select (int index)
| Selects an item.
Signal< WMenuItem * > & | itemSelected ()
| Signal which indicates that a new item was selected.
Signal< WMenuItem * > & | itemSelectRendered ()
| Signal which indicates that a new selected item is rendered.
void | close (WMenuItem *item)
| Closes an item.
void | close (int index)
| Closes an item.
std::vector< WMenuItem * > | items () const
| Returns the items.
Signal< WMenuItem * > & | itemClosed ()
| Signal which indicates that an item was closed.
void | setItemHidden (WMenuItem *item, bool hidden)
| Hides an item.
void | setItemHidden (int index, bool hidden)
| Hides an item.
bool | isItemHidden (WMenuItem *item) const
| Returns whether the item widget of the given item is hidden.
bool | isItemHidden (int index) const
| Returns whether the item widget of the given index is hidden.
void | setItemDisabled (WMenuItem *item, bool disabled)
| Disables an item.
void | setItemDisabled (int index, bool disabled)
| Disables an item.
bool | isItemDisabled (WMenuItem *item) const
| Returns whether the item widget of the given item is disabled.
bool | isItemDisabled (int index) const
| Returns whether the item widget of the given index is disabled.
WMenuItem * | currentItem () const
| Returns the currently selected item.
int | currentIndex () const
| Returns the index of the currently selected item.
void | setInternalPathEnabled (const std::string &basePath="")
| Enables internal paths for items.
bool | internalPathEnabled () const
| Returns whether the menu generates internal paths entries.
void | setInternalBasePath (const std::string &basePath)
| Sets the internal base path.
const std::string & | internalBasePath () const
| Returns the internal base path.
WStackedWidget * | contentsStack () const
| Returns the contents stack associated with the menu.
int | count () const
| Returns the item count.
WMenuItem * | itemAt (int index) const
| Returns the item by index.
int | indexOf (WMenuItem *item) const
| Returns the index of an item.
WMenuItem * | parentItem () const
| Returns the parent item (for a submenu)
virtual void | load () override
| Loads content just before the widget is used.
Public Member Functions inherited from Wt::WCompositeWidget
| WCompositeWidget ()
| Creates a WCompositeWidget.
| WCompositeWidget (std::unique_ptr< WWidget > implementation)
| Creates a WCompositeWidget with given implementation.
virtual std::vector< WWidget * > | children () const override
| Returns child widgets.
virtual std::unique_ptr< WWidget > | removeWidget (WWidget *widget) override
| Removes a child widget.
virtual void | setObjectName (const std::string &name) override
| Sets an object name.
virtual std::string | objectName () const override
| Returns the object name.
virtual const std::string | id () const override
| Returns the (unique) identifier for this object.
virtual void | setPositionScheme (PositionScheme scheme) override
| Sets the CSS position scheme.
virtual PositionScheme | positionScheme () const override
| Returns the CSS position scheme.
virtual void | setOffsets (const WLength &offset, WFlags< Side > sides=AllSides) override
| Sets CSS offsets for a non-statically positioned widget.
virtual WLength | offset (Side s) const override
| Returns a CSS offset.
virtual void | resize (const WLength &width, const WLength &height) override
| Resizes the widget.
virtual WLength | width () const override
| Returns the width.
virtual WLength | height () const override
| Returns the height.
virtual WLength | minimumWidth () const override
| Returns the minimum width.
virtual WLength | minimumHeight () const override
| Returns the minimum height.
virtual WLength | maximumWidth () const override
| Returns the maximum width.
virtual WLength | maximumHeight () const override
| Returns the maximum height.
virtual void | setLineHeight (const WLength &height) override
| Sets the CSS line height for contained text.
virtual WLength | lineHeight () const override
| Returns the CSS line height for contained text.
virtual void | setFloatSide (Side s) override
| Specifies a CSS float side.
virtual Side | floatSide () const override
| Returns the CSS float side.
virtual void | setClearSides (WFlags< Side > sides) override
| Sets the sides that should be cleared of floats.
virtual WFlags< Side > | clearSides () const override
| Returns the sides that should remain empty.
virtual void | setMargin (const WLength &margin, WFlags< Side > sides=AllSides) override
| Sets CSS margins around the widget.
virtual WLength | margin (Side side) const override
| Returns a CSS margin set.
virtual void | setHiddenKeepsGeometry (bool enabled) override
| Sets whether the widget keeps its geometry when hidden.
virtual bool | hiddenKeepsGeometry () const override
| Returns whether the widget keeps its geometry when hidden.
virtual bool | isHidden () const override
| Returns whether the widget is set hidden.
virtual bool | isVisible () const override
| Returns whether the widget is visible.
virtual void | setDisabled (bool disabled) override
| Sets whether the widget is disabled.
virtual bool | isDisabled () const override
| Returns whether the widget is set disabled.
virtual bool | isEnabled () const override
| Returns whether the widget is enabled.
virtual void | setPopup (bool popup) override
| Lets the widget overlay over other sibling widgets.
virtual bool | isPopup () const override
| Returns whether the widget is overlayed.
virtual void | setInline (bool isInline) override
| Sets whether the widget is displayed inline or as a block.
virtual bool | isInline () const override
| Returns whether the widget is displayed inline or as block.
virtual void | setDecorationStyle (const WCssDecorationStyle &style) override
| Sets a CSS decoration style.
virtual WCssDecorationStyle & | decorationStyle () override
| Returns the decoration style of this widget.
virtual void | setStyleClass (const WString &styleClass) override
| Sets (one or more) CSS style classes.
virtual WString | styleClass () const override
| Returns the CSS style class.
virtual void | addStyleClass (const WString &styleClass, bool force=false) override
| Adds a CSS style class.
virtual void | removeStyleClass (const WString &styleClass, bool force=false) override
| Removes a CSS style class.
virtual bool | hasStyleClass (const WString &styleClass) const override
| Returns whether the widget has a style class.
virtual void | setVerticalAlignment (AlignmentFlag alignment, const WLength &length=WLength::Auto) override
| Sets the vertical alignment.
virtual AlignmentFlag | verticalAlignment () const override
| Returns the vertical alignment.
virtual WLength | verticalAlignmentLength () const override
| Returns the fixed vertical alignment that was set.
virtual void | setToolTip (const WString &text, TextFormat textFormat=TextFormat::Plain) override
| Sets a tooltip.
virtual WString | toolTip () const override
| Returns the tooltip.
virtual void | setDeferredToolTip (bool enable, TextFormat textFormat=TextFormat::Plain) override
| Enable deferred tooltip.
virtual void | refresh () override
| Refresh the widget.
virtual void | setAttributeValue (const std::string &name, const WString &value) override
| Sets an attribute value.
virtual WString | attributeValue (const std::string &name) const override
| Returns an attribute value.
virtual void | setJavaScriptMember (const std::string &name, const std::string &value) override
| Sets a JavaScript member.
virtual std::string | javaScriptMember (const std::string &name) const override
| Returns the value of a JavaScript member.
virtual void | callJavaScriptMember (const std::string &name, const std::string &args) override
| Calls a JavaScript member.
virtual bool | loaded () const override
| Returns whether this widget has been loaded.
virtual void | setCanReceiveFocus (bool enabled) override
| Sets whether the widget can receive focus.
virtual bool | canReceiveFocus () const override
| Returns whether the widget can receive focus.
virtual void | setFocus (bool focus) override
| Sets focus.
virtual bool | setFirstFocus () override
| Set focus on the widget's first descendant.
virtual bool | hasFocus () const override
| Returns whether the widget currently has the focus.
virtual void | setTabIndex (int index) override
| Sets the tab index.
virtual int | tabIndex () const override
| Returns the tab index.
virtual void | setId (const std::string &id) override
| Sets the CSS Id.
virtual WWidget * | find (const std::string &name) override
| Finds a descendent widget by name.
virtual WWidget * | findById (const std::string &name) override
| Finds a descendent widget by id.
virtual void | setSelectable (bool selectable) override
| Sets as selectable.
virtual void | doJavaScript (const std::string &js) override
| Executes the given JavaScript statements when the widget is rendered or updated.
virtual void | propagateSetEnabled (bool enabled) override
| Propagates that a widget was enabled or disabled through children.
virtual bool | scrollVisibilityEnabled () const final override
| Returns whether scroll visibility detection is enabled for this widget.
virtual void | setScrollVisibilityEnabled (bool enabled) final override
| Sets whether scroll visibility detection is enabled for this widget.
virtual int | scrollVisibilityMargin () const final override
| Returns the margin around the viewport within which the widget is considered visible.
virtual void | setScrollVisibilityMargin (int margin) final override
| Sets the margin around the viewport within which the widget is considered visible.
virtual Signal< bool > & | scrollVisibilityChanged () final override
| Signal triggered when the scroll visibility of this widget changes.
virtual bool | isScrollVisible () const final override
| Returns whether this widget is currently considered scroll visible.
virtual void | setThemeStyleEnabled (bool enabled) final override
| Sets whether theme styling for a widget is enabled or disabled.
virtual bool | isThemeStyleEnabled () const final override
| Returns whether this widget is currently styled by the chosen theme.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
void | setFocus ()
| Sets focus.
Public Member Functions inherited from Wt::WWidget
virtual | ~WWidget ()
| Destructor.
WWidget * | parent () const
| Returns the parent widget.
template<typename Widget >
std::unique_ptr< Widget > | removeWidget (Widget *widget)
| Removes a child widget.
std::unique_ptr< WWidget > | removeFromParent ()
| Removes the widget from its parent.
void | setWidth (const WLength &width)
| Sets the width.
void | setHeight (const WLength &height)
| Sets the height.
virtual void | positionAt (const WWidget *widget, Orientation orientation=Orientation::Vertical)
| Positions a widget next to another widget.
virtual void | toggleStyleClass (const WString &styleClass, bool add, bool force=false)
| Toggles a CSS style class.
std::string | jsRef () const
| Returns a JavaScript expression to the corresponding DOM node.
void | setFocus ()
| Sets focus.
virtual void | acceptDrops (const std::string &mimeType, const WString &hoverStyleClass=WString())
| Sets a mime type to be accepted for dropping.
virtual void | stopAcceptDrops (const std::string &mimeType)
| Indicates that a mime type is no longer accepted for dropping.
virtual void | htmlText (std::ostream &out)
| Streams the (X)HTML representation.
bool | isRendered () const
| Returns whether the widget is rendered.
void | hide ()
| Hides the widget.
void | animateHide (const WAnimation &animation)
| Hides the widget using an animation.
void | show ()
| Shows the widget.
void | animateShow (const WAnimation &animation)
| Shows the widget using an animation.
void | enable ()
| Enables the widget.
void | disable ()
| Disable thes widget.
bool | layoutSizeAware () const
| Returns whether the widget is layout size aware.
Public Member Functions inherited from Wt::WObject
void | addChild (std::unique_ptr< WObject > child)
| Add a child WObject whose lifetime is determined by this WObject.
template<typename Child >
Child * | addChild (std::unique_ptr< Child > child)
| Add a child WObject, returning a raw pointer.
std::unique_ptr< WObject > | removeChild (WObject *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
template<typename Child >
std::unique_ptr< Child > | removeChild (Child *child)
| Remove a child WObject, so its lifetime is no longer determined by this WObject.
void | resetLearnedSlots ()
| Resets learned stateless slot implementations.
template<class T >
void | resetLearnedSlot (void(T::*method)())
| Resets a learned stateless slot implementation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)())
| Declares a slot to be stateless and learn client-side behaviour on first invocation.
template<class T >
WStatelessSlot * | implementStateless (void(T::*method)(), void(T::*undoMethod)())
| Declares a slot to be stateless and learn client-side behaviour in advance.
void | isNotStateless ()
| Marks the current function as not stateless.
template<class T >
WStatelessSlot * | implementJavaScript (void(T::*method)(), const std::string &jsCode)
| Provides a JavaScript implementation for a method.
Public Member Functions inherited from Wt::Core::observable
| observable () noexcept
| Default constructor.
virtual | ~observable ()
| Destructor.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...)) noexcept
| Protects a method call against object destruction.
template<typename... Args, typename C >
auto | bindSafe (void(C::*method)(Args...) const) const noexcept
| Protects a const method call against object destruction.
template<typename Function >
auto | bindSafe (const Function &function) noexcept
| Protects a function against object destruction.

## Protected Member Functions
virtual void | render (WFlags< RenderFlag > flags) override
| Renders the widget.
Protected Member Functions inherited from Wt::WMenu
virtual void | internalPathChanged (const std::string &path)
| Handling of internal path changes.
virtual int | nextAfterHide (int index)
| Returns the index of the item to be selected after hides.
virtual void | select (int index, bool changePath)
| Selects an item.
Protected Member Functions inherited from Wt::WCompositeWidget
virtual void | enableAjax () override
| Progresses to an Ajax-enabled widget.
void | setImplementation (std::unique_ptr< WWidget > widget)
| Set the implementation widget.
template<typename Widget >
Widget * | setImplementation (std::unique_ptr< Widget > widget)
| Sets the implementation widget, returning a raw pointer.
template<typename W , typename... Args>
W * | setNewImplementation (Args &&... args)
| Creates the implementation widget and sets it, returning a raw pointer.
WWidget * | implementation ()
| Get the implementation widget.
virtual int | boxPadding (Orientation orientation) const override
| Returns the widget's built-in padding.
virtual int | boxBorder (Orientation orientation) const override
| Returns the widget's built-in border width.
Protected Member Functions inherited from Wt::WWidget
void | setLayoutSizeAware (bool sizeAware)
| Sets the widget to be aware of its size set by a layout manager.
virtual void | layoutSizeChanged (int width, int height)
| Virtual method that indicates a size change.
| WWidget ()
| Creates a widget.
virtual void | dropEvent (WDropEvent dropEvent)
| Handles a drop event.
void | scheduleRender (WFlags< RepaintFlag > flags=None)
| Schedules rerendering of the widget.
virtual WStatelessSlot * | getStateless (Method method) override
| On-demand stateless slot implementation.
Protected Member Functions inherited from Wt::WObject

## Additional Inherited Members
Public Types inherited from Wt::WObject
typedef void(WObject::*) | Method()
| Typedef for a WObject method without arguments.
Static Public Member Functions inherited from Wt::WWidget
static WString | tr (const char *key)
| Short hand for WString::tr()
Static Public Member Functions inherited from Wt::WObject
Static Public Attributes inherited from Wt::WWidget
Protected Types inherited from Wt::WWidget
Static Protected Attributes inherited from Wt::WWidget

## Detailed Description

A menu presented in a popup window.

The menu implements a typical context menu, with support for submenu's. It is a specialized WMenu from which it inherits most of the API.

When initially created, the menu is invisible, until popup() or exec() is called. Then, the menu will remain visible until an item is selected, or the user cancels the menu (by hitting Escape or clicking elsewhere).

The implementation assumes availability of JavaScript to position the menu at the current mouse position and provide feed-back of the currently selected item.

As with WDialog, there are two ways of using the menu. The simplest way is to use one of the synchronous exec() methods, which starts a reentrant event loop and waits until the user cancelled the popup menu (by hitting Escape or clicking elsewhere), or selected an item.

Alternatively, you can use one of the popup() methods to show the menu and listen to the triggered signal where you read the result(), or associate the menu with a button using WPushButton::setMenu().

You have several options to react to the selection of an item:

- Either you use the WMenuItem itself to identify the action, perhaps by specialization or simply by binding custom data using WMenuItem::setData().
- You can bind a separate method to each item's WMenuItem::triggered signal.

Usage example:

// Create a menu with some items
WPopupMenu popup;
popup.addItem("icons/item1.gif", "Item 1");
popup.addItem("Item 2")->setCheckable(true);
popup.addItem("Item 3");
popup.addSeparator();
popup.addItem("Item 4");
popup.addSeparator();
popup.addItem("Item 5");
popup.addItem("Item 6");
popup.addSeparator();
auto subMenu = std::make_unique<Wt::WPopupMenu>();
subMenu->addItem("Sub Item 1");
subMenu->addItem("Sub Item 2");
popup.addMenu("Item 7", std::move(subMenu));
WMenuItem *item = popup.exec(event);
if (item) {
// ... do associated action.
}
Wt::WMenuItem
A single item in a menu.
Definition WMenuItem.h:31
Wt::WMenuItem::setCheckable
void setCheckable(bool checkable)
Sets if the item is checkable.
Wt::WMenu::addItem
WMenuItem * addItem(const WString &label, std::unique_ptr< WWidget > contents=nullptr, ContentLoading policy=ContentLoading::Lazy)
Adds an item.
Wt::WPopupMenu
A menu presented in a popup window.
Definition WPopupMenu.h:109
Wt::WPopupMenu::popup
void popup(const WPoint &point)
Shows the the popup at a position.

A snapshot of the WPopupMenu:

WPopupMenu example (default)
WPopupMenu example (polished)

See also
  WMenuItem

## Constructor & Destructor Documentation

## ◆ WPopupMenu()

Wt::WPopupMenu::WPopupMenu | ( | WStackedWidget * | contentsStack = nullptr | ) |

Creates a new popup menu.

The menu is hidden, by default, and must be shown using popup() or exec().

## Member Function Documentation

## ◆ aboutToHide()

Signal & Wt::WPopupMenu::aboutToHide | ( |  | ) |

Signal emitted when the popup is hidden.

Unlike the itemSelected() signal, aboutToHide() is only emitted by the toplevel popup menu (and not by submenus), and is also emitted when no item was selected.

You can use result() to get the selected item, which may be `nullptr`.

See also
  triggered(), itemSelected()

## ◆ exec() [1/3]

WMenuItem * Wt::WPopupMenu::exec | ( | const WMouseEvent & | event | ) |

Executes the the popup at the location of a mouse event.

This is a convenience method for exec(const WPoint& p) that uses the event's document coordinates.

See also
  exec(const WPoint&)

## ◆ exec() [2/3]

WMenuItem * Wt::WPopupMenu::exec | ( | const WPoint & | point | ) |

Executes the the popup at a position.

Displays the popup at a point with document coordinates `p`, using popup(), and the waits until a menu item is selected, or the menu is cancelled.

Returns the selected menu (or sub-menu) item, or `0` if the user cancelled the menu.

See also
  popup()

## ◆ exec() [3/3]

WMenuItem * Wt::WPopupMenu::exec | ( | WWidget * | location,
|  | Orientation | orientation = Orientation::Vertical )

Executes the popup besides a widget.

See also
  positionAt(), popup(const WPointF&)

## ◆ hideOnSelect()

bool Wt::WPopupMenu::hideOnSelect | ( |  | ) | const

Returns whether this popup menu should hide when an item is selected.

See also
  setHideOnSelect()

## ◆ popup() [1/3]

void Wt::WPopupMenu::popup | ( | const WMouseEvent & | event | ) |

Shows the the popup at the location of a mouse event.

This is a convenience method for popup(const WPoint&) that uses the event's document coordinates.

See also
  popup(const WPoint& p), WMouseEvent::document()

## ◆ popup() [2/3]

void Wt::WPopupMenu::popup | ( | const WPoint & | point | ) |

Shows the the popup at a position.

Displays the popup at a point with document coordinates `point`. The positions intelligent, and will chose one of the four menu corners to correspond to this point so that the popup menu is completely visible within the window.

See also
  exec()

## ◆ popup() [3/3]

void Wt::WPopupMenu::popup | ( | WWidget * | location,
|  | Orientation | orientation = Orientation::Vertical )

Shows the popup besides a widget.

See also
  positionAt(), popup(const WPointF&)

## ◆ render()

virtual void Wt::WPopupMenu::render | ( | WFlags< RenderFlag > | flags | ) |
| overrideprotectedvirtual

Renders the widget.

This function renders the widget (or an update for the widget), after this has been scheduled using scheduleRender().

The default implementation will render the widget by serializing changes to JavaScript and HTML. You may want to reimplement this widget if you have been postponing some of the layout / rendering implementation until the latest moment possible. In that case you should make sure you call the base implementation however.

Reimplemented from Wt::WMenu.

## ◆ result()

WMenuItem * Wt::WPopupMenu::result | ( |  | ) | const

Returns the last triggered menu item.

The result is `nullptr` when the user cancelled the popup menu.

## ◆ setAutoHide()

void Wt::WPopupMenu::setAutoHide | ( | bool | enabled,
|  | int | autoHideDelay = 0 )

Configure auto-hide when the mouse leaves the menu.

If `enabled`, The popup menu will be hidden when the mouse leaves the menu for longer than `autoHideDelay` (milliseconds). The popup menu result will be 0, as if the user cancelled.

By default, this option is disabled.

## ◆ setHidden()

virtual void Wt::WPopupMenu::setHidden | ( | bool | hidden,
|  | const WAnimation & | animation = WAnimation() )
| overridevirtual

Hides or shows the widget.

Hides or show the widget (including all its descendant widgets). When setting `hidden` = `false`, this widget and all descendant widgets that are not hidden will be shown. A widget is only visible if it and all its ancestors in the widget tree are visible, which may be checked using isVisible().

Note
  hide() and show() are considered to be stateless slots by default. If you override setHidden() and need to modify server state whenever it is called, you'll need to call WObject::isNotStateless().

Reimplemented from Wt::WCompositeWidget.

## ◆ setHideOnSelect()

void Wt::WPopupMenu::setHideOnSelect | ( | bool | enabled = true | ) |

Set whether this popup menu should hide when an item is selected.

Defaults to true.

See also
  hideOnSelect()

## ◆ setMaximumSize()

virtual void Wt::WPopupMenu::setMaximumSize | ( | const WLength & | width,
|  | const WLength & | height )
| overridevirtual

Sets a maximum size.

Specifies a maximum size for this widget, setting CSS `max-width` and `max-height` properties.

The default the maximum width and height are WLength::Auto, indicating no maximum size. A LengthUnit::Percentage size should not be used, as this is (in virtually all cases) undefined behaviour.

When the widget is a container widget that contains a layout manager, then setting a maximum size will have the effect of letting the size of the container to reflect the preferred size of the contents (rather than constraining the size of the children based on the size of the container), up to the specified maximum size.

See also
  resize(), setMinimumSize()

Reimplemented from Wt::WCompositeWidget.

## ◆ setMinimumSize()

virtual void Wt::WPopupMenu::setMinimumSize | ( | const WLength & | width,
|  | const WLength & | height )
| overridevirtual

Sets a minimum size.

Specifies a minimum size for this widget, setting CSS `min-width` and `min-height` properties.

The default minimum width and height is 0. The special value WLength::Auto indicates that the initial width is used as minimum size. A LengthUnit::Percentage size should not be used, as this is (in virtually all cases) undefined behaviour.

When the widget is inserted in a layout manager, then the minimum size will be taken into account.

See also
  resize(), minimumWidth(), minimumHeight()

Reimplemented from Wt::WCompositeWidget.

## ◆ triggered()

Signal< WMenuItem * > & Wt::WPopupMenu::triggered | ( |  | ) |

Signal emitted when an item is selected.

Unlike the itemSelected() signal, triggered() is only emitted by the toplevel popup menu (and not by submenus).

See also
  aboutToHide(), itemSelected()